// JavaScript
// name cahrts3dface.js
// made in http://mykaralw.pochta.ru.
//    .
//  TextBuffer.      .
//---------------------------------
//  :
// wid,hei -      .
// dat() -   .
// delta -       [%].
// name,nameD -     .
// col_p(),col_n() -    .
// bgCol() - 3    +  .
// tinfo -     [true-false].
// t_br -   .

function textcharts3dface (wid,hei,dat,delta,t_br,nameC,nameD,col_p,col_n,bgCol,tinfo)
{
	var dat_colup, dat_coldown;
	var temp_dat = 0;
	var max_dat = 0, min_dat = 0;
	var nr_dat = dat.length;
	if (delta < 1) delta = 1;
	if (delta > 99) delta = 99;
	delta = Math.ceil ((hei - 1) * (delta / 100) / (nr_dat + 1));
	var n_dat = new Array (nr_dat);
	var max_nr = 0, num_dat = 0;
	var dat_wid = 0, dat_hei = 0;
	var hei_p = 0, hei_n = 0;
	var hei_up = 0, hei_updat = 0, hei_upbl = 0, hei_downbl = 0, hei_down = 0, hei_delta = 0;
	var hei_s = (nr_dat + 1) * delta;
	var dat_m = 0;
	var tbuf = '', tbr = '';
	for (var i = 0; i < nr_dat; i++)
	{
		n_dat[i] = dat[i].length;
		num_dat += n_dat[i];
		if (max_nr < n_dat[i]) max_nr = n_dat[i];
	}
	dat_wid = Math.ceil ((wid - (t_br * max_nr))/ (nr_dat * max_nr));
	for (var i = 0; i < nr_dat; i++) for (var j = 0; j < n_dat[i]; j++) dat[i][j] *= 1;
	for (var i = 0; i < nr_dat; i++)
	{
		for (var j = 0; j < n_dat[i]; j++)
		{
			temp_dat = dat[i][j];
			if (max_dat < temp_dat) max_dat = temp_dat;
			if (min_dat > temp_dat) min_dat = temp_dat;
		}
	}
	dat_m = (hei - hei_s - 1) / (max_dat - min_dat);
	hei_p = Math.ceil (dat_m * max_dat);
	hei_n = hei - hei_p - hei_s;
	if (t_br != 0)
	{
		tbr = '\t\t<td>\n';
		tbr += '\t\t\t<table width="' + t_br + '" height="' + hei_p + '" cellpadding="0" cellspacing="0" border="0"><tbody><tr><td></td></tr></tbody></table>\n';
		tbr += '\t\t\t<table bgcolor="' + bgCol[2] + '" width="' + t_br + '" height="' + hei_s + '" cellpadding="0" cellspacing="0" border="0"><tbody><tr><td></td></tr></tbody></table>\n';
		tbr += '\t\t\t<table bgcolor="' + bgCol[2] + '" width="' + t_br + '" height="0" cellpadding="0" cellspacing="0" border="1" bordercolor="' + bgCol[2] + '"><tbody><tr><td></td></tr></tbody></table>\n';
		tbr += '\t\t</td>\n';
	}
	tbuf += '<table bgcolor="' + bgCol[0] + '"><tbody><tr><td>\n';
	tbuf += '\t<table bgcolor="' + bgCol[1] + '" width="' + wid + '" height="' + hei + '" cellpadding="0" cellspacing="0" border="1" rules="none">\n';
	tbuf += '\t<caption><b>' + nameC + '</b></caption>\n';
	tbuf += '\t<tbody><tr valign="top">\n';
	for (var j = 0; j < max_nr; j++)
	{
		for (var i = 0; i < nr_dat; i++)
		{
			tbuf += '\t\t<td>\n';
			if ((n_dat[i] - 1) < j) temp_dat = 0;
			else temp_dat = dat[i][j];
			dat_hei = Math.ceil (Math.abs (dat_m * temp_dat));
			hei_delta = (i + 1) * delta;
			hei_downbl = hei_delta;
			if (temp_dat < 0)
			{
				hei_updat = 0;
				hei_up = hei_p;
				hei_upbl = hei_s - hei_delta;
				hei_down = dat_hei - hei_downbl;
			}
			else
			{
				hei_updat = dat_hei;
				hei_upbl = hei_s - hei_delta - hei_updat;
				if (hei_upbl < 0) hei_upbl = 0;
				hei_up = hei_p + hei_s - hei_delta - hei_updat - hei_upbl;
				hei_down = 0;
			}
			dat_colup = col_p [i % col_p.length];
			dat_coldown = col_n [i % col_n.length];
			if (hei_up > 0) tbuf += '\t\t\t<table width="' + dat_wid + '" height="' + hei_up + '" cellpadding="0" cellspacing="0" border="0"><tbody><tr><td></td></tr></tbody></table>\n';
			if (hei_upbl > 0) tbuf += '\t\t\t<table bgcolor="' + bgCol[2] + '" width="' + dat_wid + '" height="' + hei_upbl + '" cellpadding="0" cellspacing="0" border="0"><tbody><tr><td></td></tr></tbody></table>\n';
			if (hei_updat > 0)
			{
				tbuf += '\t\t\t<table bgcolor="' + dat_colup + '" width="' + dat_wid + '" height="0" cellpadding="0" cellspacing="0" border="1" bordercolor="' + bgCol[3] + '"><tbody><tr><td></td></tr></tbody></table>\n';
				tbuf += '\t\t\t<table bgcolor="' + dat_colup + '" width="' + dat_wid + '" height="' + hei_updat + '" cellpadding="0" cellspacing="0" border="1" bordercolor="' + bgCol[3] + '"><tbody><tr><td></td></tr></tbody></table>\n';
			}
			if (hei_updat == 0) tbuf += '\t\t\t<table bgcolor="' + dat_colup + '" width="' + dat_wid + '" height="0" cellpadding="0" cellspacing="0" border="1" bordercolor="' + bgCol[3] + '"><tbody><tr><td></td></tr></tbody></table>\n';
			if (hei_downbl > 0) tbuf += '\t\t\t<table bgcolor="' + bgCol[2] + '" width="' + dat_wid + '" height="' + hei_downbl + '" cellpadding="0" cellspacing="0" border="0"><tbody><tr><td></td></tr></tbody></table>\n';
			if (hei_down > 0) tbuf += '\t\t\t<table bgcolor="' + dat_coldown + '" width="' + dat_wid + '" height="' + hei_down + '" cellpadding="0" cellspacing="0" border="1" bordercolor="' + bgCol[3] + '"><tbody><tr><td></td></tr></tbody></table>\n';
			tbuf += '\t\t</td>\n';
		}
		tbuf += tbr;
	}
	tbuf += '\t</tr></tbody></table>\n';
	if (tinfo)
	{
		tbuf += '\t<table><tbody>\n';
		tbuf += '\t\t<tr><td><i><b> :</b></i> ' + wid + 'x' + hei + '</td></tr>\n';
		tbuf += '\t\t<tr><td><i><b>- :</b></i> ' + num_dat + '</td></tr>\n';
		tbuf += '\t</tbody></table>\n';
	}
	tbuf += '\t<table cellpadding="1" cellspacing="0" border="1">\n';
	tbuf += '\t<caption><b>' + nameD + '</b></caption>\n';
	tbuf += '\t<tbody>\n';
	tbuf += '\t\t<tr><th></th>';
	for (var j = 0; j < max_nr; j++)
	{
		tbuf += '<th>'+ (j + 1) + '</th>';
	}
	tbuf += '</tr>\n';
	for (var i = 0; i < nr_dat; i++)
	{
		tbuf += '\t\t<tr align="center" bgcolor="' + (col_p [i % col_p.length]) + '">\n';
		tbuf += '\t\t\t<th>' + (i + 1) + '</th>\n';
		for (var j = 0; j < n_dat[i]; j++)
		{
			tbuf += '\t\t\t<td>'+ dat[i][j] + '</td>\n';
		}
		tbuf += '\t\t</tr>\n';
	}
	tbuf += '\t</tbody></table>\n';
	tbuf += '</td></tr></tbody></table>\n\n';
	return tbuf;
}
//end script
